Bug 2280062 - Review Request: python-exrex - Random string generation within bounds of regex
Summary: Review Request: python-exrex - Random string generation within bounds of regex
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: 40
Hardware: x86_64
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Ben Beasley
QA Contact: Fedora Extras Quality Assurance
URL: https://github.com/asciimoo/exrex
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR
TreeView+ depends on / blocked
 
Reported: 2024-05-10 23:51 UTC by Paul Pfeister
Modified: 2024-05-21 22:05 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: ---
Embargoed:
code: fedora-review+


Attachments (Terms of Use)
The .spec file difference from Copr build 7435197 to 7435213 (387 bytes, patch)
2024-05-11 00:16 UTC, Fedora Review Service
no flags Details | Diff
The .spec file difference from Copr build 7435213 to 7437546 (3.59 KB, patch)
2024-05-13 08:53 UTC, Fedora Review Service
no flags Details | Diff

Description Paul Pfeister 2024-05-10 23:51:02 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/ppfeister/exrex/fedora-40-x86_64/07435191-python-exrex/python-exrex.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/ppfeister/exrex/fedora-40-x86_64/07435191-python-exrex/python-exrex-0.11.0-1.fc40.src.rpm
Description: Exrex is a python module that generates all - or random - matching strings to a given regular expression and more. Exrex uses generators, so the memory usage does not depend on the number of matching strings.
Fedora Account System Username: ppfeister

Comment 1 Fedora Review Service 2024-05-10 23:54:10 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7435197
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2280062-python-exrex/fedora-rawhide-x86_64/07435197-python-exrex/fedora-review/review.txt

Found issues:

- Not a valid SPDX expression 'AGPLv3+'. It seems that you are using the old Fedora license abbreviations. Try `license-fedora2spdx' for converting it to SPDX.
  Read more: https://fedoraproject.org/wiki/Changes/SPDX_Licenses_Phase_1

Please know that there can be false-positives.

---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 3 Fedora Review Service 2024-05-11 00:16:57 UTC
Created attachment 2032623 [details]
The .spec file difference from Copr build 7435197 to 7435213

Comment 4 Fedora Review Service 2024-05-11 00:16:59 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7435213
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2280062-python-exrex/fedora-rawhide-x86_64/07435213-python-exrex/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 5 Paul Pfeister 2024-05-11 01:47:24 UTC
Working to package for distrib a popular Python OSINT tool of which I am a maintainer. This is one of a few dependencies that would need packaging beforehand. Another dependency can be found at (Request for Review) #2280050. Looking for sponsorship to allow us to distrib on the official repositories. Looking forward to working with y'all.

Comment 6 Ben Beasley 2024-05-12 23:24:55 UTC
The output of pyp2rpm is unfortunately rather outdated. Among other issues, the License is not SPDX, there are macros that obfuscate rather than simplifying, and the spec file uses the “old” Python packaging guidelines https://docs.fedoraproject.org/en-US/packaging-guidelines/Python_201x/ instead of https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/.

May I suggest something like the following? I’m happy to discuss details and provide documentation links.

Name:           python-exrex
Version:        0.11.0
Release:        %autorelease
Summary:        Irregular methods for regular expressions

License:        AGPL-3.0-or-later
URL:            https://github.com/asciimoo/exrex
# We package from the GitHub archive since the PyPI sdist lacks tests.
Source:         %{url}/archive/v%{version}/exrex-%{version}.tar.gz

BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  help2man

%global _description %{expand:
Exrex is a command line tool and python module that generates all – or random –
matching strings to a given regular expression and more.}

%description %{_description}


%package -n python3-exrex
Summary:        %{summary}

%description -n python3-exrex %{_description}


%prep
%autosetup -n exrex-%{version}


%generate_buildrequires
%pyproject_buildrequires -t


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files -l exrex

# Rely on the generated entry point %%{_bindir}/exrex; do not package
# %%{_bindir}/exrex.py, which is a copy of the entire library. If something
# needs to execute exrex.py, we can add a symbolic or hard link with than name
# for compatibility.
rm '%{buildroot}%{_bindir}/exrex.py'

# The site-packages module does not have executable permissions, so it should
# not have a shebang line.
sed -r -i '1{/^#!/d}' '%{buildroot}%{python3_sitelib}/exrex.py'

# We need to do this in %%install rather than in %%build so we can use the
# %%{_bindir}/exrex entry point.
install -d '%{buildroot}%{_mandir}/man1'
PYTHONPATH='%{buildroot}%{python3_sitelib}' help2man \
    --no-info \
    --version-string='%{version}' \
    --output='%{buildroot}%{_mandir}/man1/exrex.1' \
    '%{buildroot}%{_bindir}/exrex'


%check
%tox


%files -n python3-exrex -f %{pyproject_files}
%doc README.md
%{_bindir}/exrex
%{_mandir}/man1/exrex.1*


%changelog
%autochangelog

Comment 7 Paul Pfeister 2024-05-12 23:44:31 UTC
The original spec for this one was built with the copr's built in pyp2rpm via pypi (similar to #2280050) --- I wasn't too sure if it'd pass or not. I'll pull it into my own repo now and make some tweaks as suggested, and make it ~mine~.

Comment 8 Paul Pfeister 2024-05-13 00:31:25 UTC
Spec URL: https://raw.githubusercontent.com/ppfeister/pkg/master/python-exrex.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/ppfeister/exrex/fedora-rawhide-x86_64/07437135-python-exrex/python-exrex-0.11.0-1.fc41.src.rpm

Done! @code 

I had no idea that %autorelease existed. Going to be using that a lot more frequently. Same with %autochangelog. Going to keep that in my back pocket as well.

This version works wonderfully. A lot more readable as well. Going to revise #2280050 similarly. I may have to update my Sherlock request as well given the types of changes made. Seems like I've got some work to do there.

___

Your comment before `rm '%{buildroot}%{_bindir}/exrex.py'`. Are you saying this to avoid having ~both~ the exrex bin ~and~ exrex.py available, since we only want the one? Just want to confirm my understanding here.

We don't seem to have a man page via help2man, but that's something I can continue to research later.

Comment 9 Fedora Review Service 2024-05-13 08:53:09 UTC
Created attachment 2032891 [details]
The .spec file difference from Copr build 7435213 to 7437546

Comment 10 Fedora Review Service 2024-05-13 08:53:11 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7437546
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2280062-python-exrex/fedora-rawhide-x86_64/07437546-python-exrex/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 11 Ben Beasley 2024-05-14 14:18:49 UTC
(In reply to Paul Pfeister from comment #8)
> Your comment before `rm '%{buildroot}%{_bindir}/exrex.py'`. Are you saying
> this to avoid having ~both~ the exrex bin ~and~ exrex.py available, since we
> only want the one? Just want to confirm my understanding here.

There are two issues/questions here.

First, do we want to have both /usr/bin/exrex and /usr/bin/exrex.py? One comes from

  https://github.com/asciimoo/exrex/blob/1c22c7066f7ed1420e3ad8efe28d7be16fe98ff9/setup.py#L96

and the other comes from

  https://github.com/asciimoo/exrex/blob/1c22c7066f7ed1420e3ad8efe28d7be16fe98ff9/setup.py#L105

It’s permissible to have both, and one could argue either way, but I am not convinced upstream really strongly intended this. I suppose you could ask them. A command without the .py extension is much more “normal” in the system PATH.

Second, *if* you decide that /usr/bin/exrex.py should be packaged, it doesn’t make sense for it to be a duplicate copy of the entire library module installed in %{python3_sitelib}/exrex.py. (Note that /usr/bin/exrex is a very short generated entry-point script that relies on the module from %{python3_sitelib}). So *if* you retain /usr/bin/exrex.py, you should replace it with a symbolic or hard link to /usr/bin/exrex, something like (add -s if you want a symbolic link instead of a hardlink):

  ln -f exrex '%{buildroot}%{_bindir}/exrex.py'

Hope that helps.

> We don't seem to have a man page via help2man, but that's something I can
> continue to research later.

Oops! It worked for me in a virtualenv, but I didn’t test it in my suggested spec file. Let me look into that.

Comment 12 Ben Beasley 2024-05-14 14:21:15 UTC
Hmm, the man page was correctly generated for me using the spec from https://bugzilla.redhat.com/show_bug.cgi?id=2280062#c6.

Comment 14 Ben Beasley 2024-05-14 14:28:27 UTC
I noticed this in the build logs:

+ env /usr/lib/rpm/redhat/brp-python-bytecompile '' 1 0 -j16
Bytecompiling .py files below /builddir/build/BUILDROOT/python-exrex-0.11.0-1.fc41.x86_64/usr/lib/python3.12 using python3.12
/usr/lib/python3.12/site-packages/exrex.py:54: SyntaxWarning: invalid escape sequence '\w'
/usr/lib/python3.12/site-packages/exrex.py:56: SyntaxWarning: invalid escape sequence '\W'
/usr/lib/python3.12/site-packages/exrex.py:54: SyntaxWarning: invalid escape sequence '\w'
/usr/lib/python3.12/site-packages/exrex.py:56: SyntaxWarning: invalid escape sequence '\W'

This doesn’t *have* to be fixed, but it reflects improper escaping of regexes. I was going to say that this is something we can easily help upstream fix, but someone beat us to it in https://github.com/asciimoo/exrex/pull/69.

It wouldn’t hurt to apply this PR as a patch by adding

  # fix invalid escape sequence in regex
  # https://github.com/asciimoo/exrex/pull/69
  Patch:          https://github.com/asciimoo/exrex/pull/69.patch

and changing

  %autosetup -n exrex-%{version}

to

  %autosetup -n exrex-%{version} -p1

Comment 15 Ben Beasley 2024-05-14 15:27:30 UTC
The package is APPROVED as-is, with a couple of recommendations below:

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== Notes (no change required for approval) =====

- As noted in https://bugzilla.redhat.com/show_bug.cgi?id=2280062#c14, it might
  be a good idea to backport https://github.com/asciimoo/exrex/pull/69 as a
  patch to fix several instances of SyntaxWarning: invalid escape sequence.

- A spelling error was detected by rpmlint:

    python-exrex.src: E: spelling-error ('maching', '%description -l en_US maching -> making, macing, aching')
    python3-exrex.noarch: E: spelling-error ('maching', '%description -l en_US maching -> making, macing, aching')

  It looks like this was introduced while editing the spec file and is not
  present in the upstream description. Please fix the typo when you import the
  package.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU Affero General Public License
     v3.0", "GNU Affero General Public License v3.0 or later", "*No
     copyright* GNU Affero General Public License v3.0". 7 files have
     unknown license. Detailed output of licensecheck in
     /home/ben/Downloads/review/2280062-python-exrex/licensecheck.txt
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/doc, /usr, /usr/lib/python3.12,
     /usr/share, /usr/lib, /usr/lib/python3.12/site-packages/__pycache__,
     /usr/share/man, /usr/lib/python3.12/site-packages,
     /usr/share/man/man1, /usr/bin

     These diagnostics are spurious (known fedora-review bug).

[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/doc, /usr,
     /usr/lib/python3.12, /usr/share, /usr/lib, /usr/lib/python3.12/site-
     packages/__pycache__, /usr/share/man, /usr/lib/python3.12/site-
     packages, /usr/share/man/man1, /usr/bin

     These diagnostics are spurious (known fedora-review bug).

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 4687 bytes in 1 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[-]: Binary eggs must be removed in %prep
     Note: Cannot find any build in BUILD directory (--prebuilt option?)
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.

     (tests pass)

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.

     https://koji.fedoraproject.org/koji/taskinfo?taskID=117683091

[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-exrex-0.11.0-1.fc41.noarch.rpm
          python-exrex-0.11.0-1.fc41.src.rpm
=========================================================================================== rpmlint session starts ==========================================================================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpax4bpv2u')]
checks: 32, packages: 2

python-exrex.src: E: spelling-error ('maching', '%description -l en_US maching -> making, macing, aching')
python3-exrex.noarch: E: spelling-error ('maching', '%description -l en_US maching -> making, macing, aching')
====================================================== 2 packages and 0 specfiles checked; 2 errors, 0 warnings, 7 filtered, 2 badness; has taken 0.6 s =====================================================




Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 1

python3-exrex.noarch: E: spelling-error ('maching', '%description -l en_US maching -> making, macing, aching')
 1 packages and 0 specfiles checked; 1 errors, 0 warnings, 3 filtered, 1 badness; has taken 0.1 s 



Source checksums
----------------
https://github.com/asciimoo/exrex/archive/v0.11.0/exrex-0.11.0.tar.gz :
  CHECKSUM(SHA256) this package     : 2df167ef3beed2f41d9e539de763332e6d357fd214a06294ac5f4302cc6609f4
  CHECKSUM(SHA256) upstream package : 2df167ef3beed2f41d9e539de763332e6d357fd214a06294ac5f4302cc6609f4


Requires
--------
python3-exrex (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)



Provides
--------
python3-exrex:
    python-exrex
    python3-exrex
    python3.12-exrex
    python3.12dist(exrex)
    python3dist(exrex)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2280062 --mock-options=--dnf
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Python, Generic
Disabled plugins: R, Perl, fonts, Ocaml, Haskell, SugarActivity, Java, C/C++, PHP
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comment 16 Paul Pfeister 2024-05-14 18:34:55 UTC
re Comment 11:

That's a pretty solid explanation. I'm with you now.

re Comment 12 and Comment 13 (man page):

You're correct. It turns out that it was an issue on my end, with pieces left over from an old version of the package from testing.

re Comment 14:

Finally, a use for GitHub's .patch!
I'll revise and include that as such before publishing.

re Comment 15:

agh. I'll fix that typo as well. It should be "matching". I completely missed that one in review.

___

Appreciate the Approval and the detailed review!

I'll go ahead and do whatever the documentation says I need to do for next steps and I'll go ahead and apply your recommendations as well.
Once changes are applied I'll post a minor update here just to keep things tracked.

Comment 17 Paul Pfeister 2024-05-14 19:58:19 UTC
Spec URL: https://raw.githubusercontent.com/ppfeister/pkg/master/python-exrex.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/ppfeister/exrex/fedora-rawhide-x86_64/07444747-python-exrex/python-exrex-0.11.0-1.fc41.src.rpm

Updated the spec with your recommendations! (Same spec url, linked for convenience and for the bot)
The patch seems to apply perfectly.

There is a similar issue found in the upstream's tests.py, but I'll have to test that locally before applying a second patch and opening a pr. Not a breaking issue however.


Note You need to log in before you can comment on or make changes to this bug.